@use "sass:map";
@use "../../core/" as adm;

$name: 'adm-switch';
$component-tokens: (
	#{$name}: (
		default: (

			// backgrounds
			background: #ccc,
            background-on: adm.color('primary', red),

			// outline for focus
			outline-offset: 2px,
			outline: 2px solid #000,
			
			radius: 10px,

			padding-x: 2px,
			padding-y: 0,
			// size
            width: 4rem,
            height: 2.2rem,

			// toggle
			toggle-width: 2rem,
			toggle-height: 2rem,
			toggle-background: green,
			toggle-background-on: lightgreen,
			toggle-radius: 10px,
			toggle-transition: 'transform 0.2s ease-in-out',
            
			// typo
			font-family: inherit,
            font-weight: 400,
            font-size: inherit,
            line-height: inherit,

		),
	),
) !default;

//@include adm.generate-component-tokens($component-tokens, '.adm-button');

// generate the button markup 
@mixin generate-component-markup() {
	:host {
		box-sizing: border-box;
	}

	.#{$name} {	

		position: relative;
		display: inline-flex;
		text-decoration: none;
		box-sizing: border-box;
		

		input[type="checkbox"] {
			position: relative;
			appearance: none;
			cursor: pointer;
			padding: adm.c-token($name, 'padding-y') adm.c-token($name, 'padding-x');
			background: adm.c-token($name, 'background');
			width: adm.c-token($name, 'width');
			height: adm.c-token($name, 'height');
			border-radius: adm.c-token($name, 'radius');

			&::before {
				content: '';
				display: block;
				position: absolute;
				top: calc(50% - (adm.c-token($name, 'toggle-height')/2));
				width: adm.c-token($name, 'toggle-width');
				height: adm.c-token($name, 'toggle-height');
				background: adm.c-token($name, 'toggle-background');
				border-radius: adm.c-token($name, 'toggle-radius');
				transition: adm.c-token($name, 'toggle-transition');
			}

			&:checked {

				background: adm.c-token($name, 'background-on');
				&::before {
					transform: translateX(calc(#{adm.c-token($name, 'width')} - #{adm.c-token($name, 'toggle-width')} - (#{adm.c-token($name, 'padding-x')} * 2)));
				}        		
			}

		} 

		
	}

	:host([disabled]),
    [disabled] {
        opacity: 0.4;
        pointer-events: none;
    }

	// individual code
	@content;

}